<?php
defined('_JEXEC') or die;

class ModJlmsShortMenuHelper
{
	//Warning: do not change incoming parameters of this function. This helper is used in the ShortMenu widget.
	public static function getList($params)
	//Warning: do not change incoming parameters of this function. This helper is used in the ShortMenu widget.
	{
		$list = array();

		$app = JFactory::getApplication();

//		if($app->input->getCmd('option') == 'com_joomla_lms'){
		if(true){
			$pathToLms = JPATH_SITE . '/components/com_joomla_lms';

			if (!defined('_JOOMLMS_FRONT_HOME')) { define('_JOOMLMS_FRONT_HOME', $pathToLms); }

			require_once (_JOOMLMS_FRONT_HOME . '/libraries/servicelocator.php');

			require_once (_JOOMLMS_FRONT_HOME . '/includes/lms_legacy.php');
			require_once (_JOOMLMS_FRONT_HOME . '/joomla_lms.main.php');
			require_once (_JOOMLMS_FRONT_HOME . '/includes/libraries/lms.lib.language.php');

			\LMS\Libraries\ServiceLocator::registerNamespace('LMS', $pathToLms);
			\LMS\Libraries\ServiceLocator::activate();

			\LMS\Libraries\ServiceLocator::load('lib.base');
			\LMS\Libraries\ServiceLocator::load('tool.coursebuilder');

			$jlmsConfig = \LMS\Libraries\ServiceLocator::get('config');

			$languageProcessor = \LMS\Libraries\Language::getInstance();
			$languageProcessor->process('main');

			$currentUserType = $jlmsConfig->get('current_usertype');

			if($currentUserType === null){
				$currentUserType = -1;
			} else {
				$currentUserType = 0;
			}

			$courseId = $jlmsConfig->get('course_id');

			$modelLearningPattern = new \LMS\Tools\Coursebuilder\Model\LearningPattern();
			$modelLearningPattern->setState('courseId', $courseId);

			$lmsMainMenuItems = $modelLearningPattern->getMainTools($currentUserType);

			$item_id = $jlmsConfig->get('Itemid');
			$item_id = isset($item_id) && $item_id ? "&Itemid=".$item_id : '';

			$system_menu_class_path = JPATH_SITE . DS . 'components' . DS . 'com_joomla_lms' . DS . 'includes' . DS . 'classes' . DS . 'lms.system_menu.php';
			if (file_exists($system_menu_class_path)){

				require_once($system_menu_class_path);

				$list = ModJlmsShortMenuHelper::proccessLink($lmsMainMenuItems, $jlmsConfig, $courseId, $item_id);
			}

			$jlmsAssets = \LMS\Libraries\ServiceLocator::get('assets');
			$jlmsAssets->addStyleSheet('/assets/css/style.css');
			$jlmsAssets->addStyleSheet('/assets/css/jlmsicons/style.css');
		}

		return $list;
	}

	static function proccessLink($items, $jlmsConfig, $courseId, $item_id)
	{
		foreach($items as $item){
			if(isset($item->lang_var) && $item->lang_var){

				if(isset($item->link)){
					break;
				}

				$task = '';
				if ($item->task){
					$task = "&task=".$item->task;
				}

				if ($item->lang_var == '_JLMS_TOOLBAR_HOME')
				{
					$task = "&view=default";
				}

				if (
					$item->lang_var == '_JLMS_TOOLBAR_COURSES' ||
					$item->lang_var == '_JLMS_TOOLBAR_HOME' ||
					$item->lang_var == '_JLMS_TOOLBAR_SUBSCRIPTIONS' ||
					$item->lang_var == '_JLMS_TOOLBAR_LIBRARY' ||
					$item->lang_var == '_JLMS_REPORTS_ACCESS' ||
					$item->lang_var == '_JLMS_REPORTS_CONCLUSION' ||
					$item->lang_var == '_JLMS_REPORTS_USER'
				){
					$ids = '';
				} else {
					$ids = "&id=".$courseId;
				}

				if ($item->lang_var == '_JLMS_TOOLBAR_HELP'){
					$item->link = 'http://www.joomlalms.com/index.php?option=com_lms_help&Itemid=40&task=view_by_task&key=';
				} else {
					if ($jlmsConfig->get('under_ssl') && $jlmsConfig->get('real_live_site')) {
						$item->link = $jlmsConfig->get('real_live_site') . "/index.php?option=com_joomla_lms".$item_id.$task.$ids;
					} else {
						$item->link = JLMSRoute::_("index.php?option=com_joomla_lms".$task.$ids.$item_id);
					}
				}
				if ($item->lang_var == '_JLMS_TOOLBAR_GQP_PARENT'){
					$item->link = JLMSRoute::_("index.php?option=com_joomla_lms&amp;task=global_pool".$item_id);
				}

				if(isset($item->childTools) && count($item->childTools)){
					$item->childTools = ModJlmsShortMenuHelper::proccessLink($item->childTools, $jlmsConfig, $courseId, $item_id);
				}
			}
		}
		return $items;
	}
}