<?php
defined('_JEXEC') or die;

echo $this->widget('contentheader');
echo $this->widget('contenttoolbar');
$courseId = $this->config->get('course_id');

?>

<div class="row-fluid">



<div class="media" style="max-width:1000px; margin:auto; border: 1px solid #ebebeb; border-radius: 4px; margin-bottom:12px;">
    <div class="media-left" style="padding-top:10px; padding-bottom:10px; padding-left:10px; min-width:128px; text-align: center;">
	<span class="jlmsicon-webinars jlms-icon-logo-small" style=></span>
    </div>
    <div class="media-body" style="padding-top:10px; padding-bottom:10px;">
	<h2>Webinars</h2>
	<div class="row-fuid">
		For better organization of the learning process you can schedule webinars and assign students to them. Before using the Webinars tool make sure that GoToMeeting plugin is carefully configured by the site administrator.
	</div>
    </div>
    <div class="media-right" style="padding-top:10px; padding-bottom:10px; padding-right:10px;">
	<?php echo new \LMS\Widgets\Button(array('type' => 'custom', 'title' =>'Open', 'icon' => 'new-tab', 'iconPosition' => 'right', 'nowrap' => 'true', 'target' => '_blank', 'href' => JLMSRoute::_("index.php?option=com_joomla_lms&task=conference&id=$courseId")));; ?>
    </div>
</div>

<div class="media" style="max-width:1000px; margin:auto; border: 1px solid #ebebeb; border-radius: 4px; margin-bottom:12px;">
    <div class="media-left" style="padding-top:10px; padding-bottom:10px; padding-left:10px; min-width:128px; text-align: center;">
	<span class="jlmsicon-quizzes jlms-icon-logo-small"></span>
    </div>
    <div class="media-body" style="padding-top:10px; padding-bottom:10px;">
	<h2>Quizzes</h2>
	<div class="row-fuid">
		Quiz is a type of examination consisting of several questions. Quizzes can be used as intermediate or final tests into the learning paths.  Use the Quizzes tool to create course quizzes and exams.
	</div>
    </div>
    <div class="media-right" style="padding-top:10px; padding-bottom:10px; padding-right:10px;">
	<?php echo new \LMS\Widgets\Button(array('type' => 'custom', 'title' =>'Open', 'icon' => 'new-tab', 'iconPosition' => 'right', 'nowrap' => 'true', 'target' => '_blank', 'href' => JLMSRoute::_("index.php?option=com_joomla_lms&task=quizzes&id=$courseId")));; ?>
    </div>
</div>

<div class="media" style="max-width:1000px; margin:auto; border: 1px solid #ebebeb; border-radius: 4px; margin-bottom:12px;">
    <div class="media-left" style="padding-top:10px; padding-bottom:10px; padding-left:10px; min-width:128px; text-align: center;">
	<span class="jlmsicon-documents jlms-icon-logo-small"></span>
    </div>
    <div class="media-body" style="padding-top:10px; padding-bottom:10px;">
	<h2>Documents</h2>
	<div class="row-fuid">
		Documents represent a repository of files that can be downloaded or viewed online by your Students. Use the Documents tool to upload various types of materials or add them as steps into Learning Paths.
	</div>
    </div>
    <div class="media-right" style="padding-top:10px; padding-bottom:10px; padding-right:10px;">
	<?php echo new \LMS\Widgets\Button(array('type' => 'custom', 'title' =>'Open', 'icon' => 'new-tab', 'iconPosition' => 'right', 'nowrap' => 'true', 'target' => '_blank', 'href' => JLMSRoute::_("index.php?option=com_joomla_lms&task=documents&id=$courseId")));; ?>
    </div>
</div>

<div class="media" style="max-width:1000px; margin:auto; border: 1px solid #ebebeb; border-radius: 4px; margin-bottom:12px;">
    <div class="media-left" style="padding-top:10px; padding-bottom:10px; padding-left:10px; min-width:128px; text-align: center;">
	<span class="jlmsicon-learning_path jlms-icon-logo-small"></span>
    </div>
    <div class="media-body" style="padding-top:10px; padding-bottom:10px;">
	<h2>Learning Paths</h2>
	<div class="row-fuid">
		A Learning Path is a sequence of steps that all Students taking part in a course should complete. Use the Learning Paths tool  to create educational lines in the studying process.
	</div>
    </div>
    <div class="media-right" style="padding-top:10px; padding-bottom:10px; padding-right:10px;">
	<?php echo new \LMS\Widgets\Button(array('type' => 'custom', 'title' =>'Open', 'icon' => 'new-tab', 'iconPosition' => 'right', 'nowrap' => 'true', 'target' => '_blank', 'href' => JLMSRoute::_("index.php?option=com_joomla_lms&task=learnpaths&id=$courseId")));; ?>
    </div>
</div>


</div>